var url_post_ctrl = "/post_ctrl";
var url_post_sensor = "/post_sensor";
var flgTime = false;
var timerHundle = null;

var csvFilename =  "temperature_data.csv";

colorTable = {
    "START":"background-color:#daf6ff",
    "STOP":"background-color:#eeeeee"
 }

 // Jaonデータをcsvファイルで保存するまえのBlobオブジェクトに変換するクラス
 const jsonCsvBlobClass = class {
    constructor(header){
      this.header = header;
      this.init = header;
      //this.body = body;            
    }
    push = (data) =>{
        this.header += data;
    }
    get = () => {            
        return this.header         
    }
    
    initBody = () => {
        this.header =  this.init;
    }

    getBlob = () => {              
        const data = this.get();
        const bom = new Uint8Array([0xef, 0xbb, 0xbf]);           //BOMを付与する（Excelでの文字化け対策）
        const blob = new Blob([bom, data], { type: "text/csv" }); //Blobでデータを作成する
        this.initBody();
        return blob;
     }
  }
  var header = "TEMP"  + "," + "U" + "," + "P"   + "," + "I"   + ","  + "D"   + "," +  "E"  + "\n";
  //var bodyInit = "0.0" + "," + "0.0"  + "," + "0.0" + "," + "0.0" + ","  + "0.0" + "," + "0.0" + "\n";
  const csvBlob = new jsonCsvBlobClass(header);
  // BlobデータからCSVファイルを作成する。
  function createCSV(){
    const blob = csvBlob.getBlob();
    if (window.navigator.msSaveBlob) {                                      //IE10/11用(download属性が機能しないためmsSaveBlobを使用）
        window.navigator.msSaveBlob(blob, filename);
    } else {                                                                 //その他ブラウザ
        const filename = csvFilename;
        const url = (window.URL || window.webkitURL).createObjectURL(blob); //BlobからオブジェクトURLを作成する
        const download_file = document.createElement("a");                  //ダウンロード用に a アンカータグ（リンク）を作成する
        download_file.href = url;                                           //リンク先に上記で生成したURLを指定する
        download_file.download = filename;                                  //download属性にファイル名を指定する
        download_file.click();                                              //作成したリンクをクリックしてダウンロードを実行する
        (window.URL || window.webkitURL).revokeObjectURL(url);              //createObjectURLで作成したオブジェクトURLを開放する
     } 
  }
  const button_download = document.getElementById("download");              //ボタンを取得する
  button_download.addEventListener("click", createCSV, false);              //ボタンがクリックされたら「downloadCSV」を実行する
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// サーバーにPOST送信するJSONデータを生成するクラス
class makeingPortStatJsonData{
    constructor() {
        this.portStat =  { 
        "START/STOP":"STOP", "target":33.0,"kp":29.0, "ki":1.5, "kd":5.2, "ctrl":"PID"
        };
        console.log(this.portStat);
        this.sensorStat =  { 
            "TEMP":0.00, "HUMI":0.00, "P":0.00, "I":0.00, "D":0.00, "E":0.00
            };
        console.log(this.sensorStat);
    }
    // ポートマップを作り、JSONデータを生成する。
    getJSON_port(portname){
        var before = Object.assign({}, this.portStat);
        if ( this.portStat[portname] === "STOP" ) {
            this.portStat[portname] = "START";
        } else {
            this.portStat[portname] = "STOP";
        }
        this.portStat["target"] = parseFloat(document.getElementById("target-temp").value);
        this.portStat["kp"] = parseFloat(document.getElementById("kp").value);
        this.portStat["ki"] = parseFloat(document.getElementById("ki").value);
        this.portStat["kd"] = parseFloat(document.getElementById("kd").value);
        this.portStat["ctrl"] = this.getControl_method();
        console.log(this.portStat);
        var json_data = JSON.stringify(this.portStat);
        return json_data;
    }
    // GET命令と温度と湿度データを受け取る箱からなるマップを作り、JSONデータを生成する。
    getJSON_sensor(){
        var json_data = JSON.stringify(this.sensorStat);
        return json_data;
    }

    getControl_method(){
        let method;
        let elements = document.getElementsByName("control-method");
        for(let i=0; i < elements.length;  i++){
            if( elements.item(i).checked ){
                method = elements.item(i).value;
            }
        }
        return method;
    }
}

const PortStatJsonData = new makeingPortStatJsonData();

// clickイベント処理
document.body.addEventListener("click", function(event){
        var eventClass = event.target.className;
        if ( eventClass === "PORT" ) { 
            // LED制御テスト画面からの、LED番号指定によるJSONデータの生成と、POST送信
            var json_data = PortStatJsonData.getJSON_port(event.target.id);
            xhrPost_port(url_post_ctrl, json_data);
        }
} ,false);

var json_data = PortStatJsonData.getJSON_sensor();
if(flgTime == false) {
	timerHundle = setInterval(xhrPost_sensor, 1000, url_post_sensor, json_data);
	flgTime = true;
}
window.onbeforeunload = function(e) {
	if(flgTime) {
		clearInterval(timerHundle);
	}
}
   
function xhrPost_port(url, jsondata) {
    // XHRの宣言
    var XHR = new XMLHttpRequest();
    // openメソッドにPOSTを指定して送信先のURLを指定する
    XHR.open("POST", url, true);
    
    // sendメソッドにデータを渡して送信を実行する
    XHR.setRequestHeader('Context-Type', 'application/json');
    XHR.send( jsondata );
    
    // サーバの応答をonreadystatechangeイベントで検出して正常終了したらデータを取得する
    XHR.onreadystatechange = function(){
        if(XHR.readyState == 4 && XHR.status == 200){
            // POST送信した結果を表示する
            // サーバーが返したjsonデータを用いてボタンの色（状態）を変える
            let responseJson = JSON.parse(XHR.response);
            for( var key in responseJson ) {
                if (key == "START/STOP") {
                    document.getElementById(key).style = colorTable[responseJson[key]];
                }                                                                
            }          
        } else {

        }
    };
}

function xhrPost_sensor(url, jsondata) {
    // XHRの宣言
    var XHR = new XMLHttpRequest();
    // openメソッドにPOSTを指定して送信先のURLを指定する
    XHR.open("POST", url, true);
    
    // sendメソッドにデータを渡して送信を実行する
    XHR.setRequestHeader('Context-Type', 'application/json');
    XHR.send( jsondata );
    
    // サーバの応答をonreadystatechangeイベントで検出して正常終了したらデータを取得する
    XHR.onreadystatechange = function(){
        if(XHR.readyState == 4 && XHR.status == 200){
            // POST送信した結果を表示する
            // サーバーが返したjsonデータを用いて温度と湿度を表示する。
             let responseJson = JSON.parse(XHR.response);
                for( var key in responseJson ) {
                    // if( (key === "TEMP") || (key === "HUMI")) {
                     if(key === "TEMP"){
                        document.getElementById(key).innerHTML = (responseJson[key]).toFixed(2);                     
                    }                                                                                          
                }
                var temp = (responseJson["TEMP"]).toFixed(2);
                var u = (responseJson["U"]).toFixed(2);
                var p =  (responseJson["P"]).toFixed(2);
                var i =  (responseJson["I"]).toFixed(2);
                var d =  (responseJson["D"]).toFixed(2);
                var e =  (responseJson["E"]).toFixed(2);
                var data = temp + "," + u + "," + p + "," + i + "," + d + "," + e + "\n";
                csvBlob.push(data);     // csvファイルとして保存用にバッファリング（jsonCsvBlobClassクラスのメソッドを実行）
                
        } else {

        }
    };
}

